﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

namespace RptGenWebDemo
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            //Create DataSet
            var TestDs = new DataSet("TestDs");
            TestDs.ReadXmlSchema(MapPath("AdWorkSC.xml"));
            TestDs.ReadXml(MapPath("AdWorkDT.xml"));




            //Create RdlcRptGen Class object and pass table that is to be displayed. 
            //The single line below is all that is needed, report will be displayed.
            //var CrtGen = new RdlcRptGen.RdlcGenClass(TestDs.Tables[0],ReportViewer1 );
            //return;


            //Optionally pass only the table and then select some of the options below.
            var CrtGen = new RdlcRptGen.RdlcGenClass(TestDs.Tables[0]);

            //To show a chart change below to "false";
            if (true)
            {
                //Then optionally select a grouping field. The report will then be grouped by this field.
                CrtGen.GroupByField = "City";

                //Optionally select report and group total column. These columns will be totaled on the generated report.
                CrtGen.AddReportTotalFields("VacationHours");
                CrtGen.AddReportTotalFields("SickLeaveHours");
                CrtGen.AddGroupTotalFields( "VacationHours");
                CrtGen.AddGroupTotalFields( "SickLeaveHours");

                //Optionally select the columns to be included in the report.
                //The second and third parameter, the column width, and the ColumnHeader need not be provided,
                //The default values will be used.
                CrtGen.AddReportColumns("LastName", "3in", "Last Name");
                CrtGen.AddReportColumns("BirthDate", "2in", "BirthDate");
                CrtGen.AddReportColumns("VacationHours", "1in", "Vacation Hours");
                CrtGen.AddReportColumns("SickLeaveHours", "1in", "Sick Leave Hours");
                CrtGen.AddReportColumns("City", "1in", "City");

                //Optionally include a report header.
                CrtGen.AddReportHeader("This is a report header");

                //Optionally generate the report definition file (RDLC) and save it to for future use.
                CrtGen.GenerateRdl(MapPath("DebugRDLC.RDLC"));
                
                
                //Show report.
                CrtGen.ShowReport(ReportViewer1);


            }
            else
            {
                //To show a Chart.
                
                //Add chart Data Points.
                CrtGen.AddChartDataPoint("VacationHours", null);
                CrtGen.AddChartDataPoint("SickLeaveHours", "Sum");
                
                //Optionally Add Chart type and Chart Data Point Grouping.
                CrtGen.AddChartTypeAndGrouping("Column", "City");

                //Optionally add a Title to the Chart.
                CrtGen.AddChartTitle("Test Title");

                //Optionally add Data Point lables and X and Y axis labels
                CrtGen.ChartLables(true, "X axis label", "Y axis label");

                //Show Chart.
                CrtGen.ShowChart(this.ReportViewer1);
            }
        }
    }
}
